// Sample04.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
	PTC_PORT	portList;
	ULONG		numPorts;
	TC_STATUS	status;
	ULONG		i;
	ULONG		numPort;
	TC_PORT	port;

	UNUSED(argc);
	UNUSED(argv);

	status = TcQueryPortList(&portList, &numPorts);

	if (status != TC_SUCCESS)
	{
		printf("Cannot retrieve port list, %s\n", TcStatusGetString(status));
		return -1;
	}

	if (numPorts == 0)
	{
		printf("No ports available.\n");
		return 0;
	}
	
	do
	{
		for (i = 0; i < numPorts; i++)
		{
			if (TcPortGetType(portList[i]) == TC_PORT_TYPE_PHYSICAL)
			{
				printf("%u) %s (%s)\n", i, TcPortGetDescription(portList[i]), TcPortGetName(portList[i]));
			}
		}

		printf("\nPort number? ");
	}
	while((scanf_s("%u", &numPort) == 0 ) || (numPort >= numPorts) || (TcPortGetType(portList[numPort]) != TC_PORT_TYPE_PHYSICAL));

	port = portList[numPort];

	do
	{
		printf("Turning LED0 on for 5 seconds...");
		status = TcPortSetFeature(port, TC_PRT_FT_LED_0, TC_PRT_LED_ON);
		
		if (status != TC_SUCCESS)
		{
			printf("Error: %s (%08x)\n", TcStatusGetString(status), status);
		}
		else
		{
#ifdef _WIN32
			Sleep(5000);
#else
			sleep(5);
#endif
			printf("DONE\n");
		}

		printf("Turning LED0 off for 5 seconds...");
		status = TcPortSetFeature(port, TC_PRT_FT_LED_0, TC_PRT_LED_OFF);
		
		if (status != TC_SUCCESS)
		{
			printf("Error: %s (%08x)\n", TcStatusGetString(status), status);
		}
		else
		{
#ifdef _WIN32
			Sleep(5000);
#else
			sleep(5);
#endif
			printf("DONE\n");
		}

		printf("Turning LED0 blink for 5 seconds...");
		status = TcPortSetFeature(port, TC_PRT_FT_LED_0, TC_PRT_LED_BLINK);
		
		if (status != TC_SUCCESS)
		{
			printf("Error: %s (%08x)\n", TcStatusGetString(status), status);
		}
		else
		{
#ifdef _WIN32
			Sleep(5000);
#else
			sleep(5);
#endif
			printf("DONE\n");
		}

		printf("Turning LED0 to default...");
		status = TcPortSetFeature(port, TC_PRT_FT_LED_0, TC_PRT_LED_DEFAULT);
		
		if (status != TC_SUCCESS)
		{
			printf("Error: %s (%08x)\n", TcStatusGetString(status), status);
		}
		else
		{
			printf("DONE\n");
		}

	}while(FALSE);

	TcFreePortList(portList);

	if (status != TC_SUCCESS)
		return -1;

	return 0;

}

