// Sample04.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
	PTC_PORT	portList;
	ULONG		numPorts;
	TC_STATUS	status;
	ULONG		i;
	ULONG		numPort;
	TC_PORT	port;
#ifndef _WIN32
	CHAR ch;
#endif

	UNUSED(argc);
	UNUSED(argv);

	status = TcQueryPortList(&portList, &numPorts);

	if (status != TC_SUCCESS)
	{
		printf("Cannot retrieve port list, %s\n", TcStatusGetString(status));
		return -1;
	}

	if (numPorts == 0)
	{
		printf("No ports available.\n");
		return 0;
	}
	
	do
	{
		for (i = 0; i < numPorts; i++)
		{
			if (TcPortGetType(portList[i]) == TC_PORT_TYPE_PHYSICAL)
			{
				printf("%u) %s (%s)\n", i, TcPortGetDescription(portList[i]), TcPortGetName(portList[i]));
			}
		}

		printf("\nPort number? ");
	}
	while((scanf_s("%u", &numPort) == 0 ) || (numPort >= numPorts) || (TcPortGetType(portList[numPort]) != TC_PORT_TYPE_PHYSICAL));

	port = portList[numPort];

	do
	{
		TC_LINK_INFO linkInfo;

		status = TcPortQueryLinkStatus(port, &linkInfo);
		if (status != TC_SUCCESS) break;

		printf("Current status of the port is: ");
		if (linkInfo.LinkUp)
		{
			printf("UP, speed = %uMbps", linkInfo.LinkSpeed);
			switch(linkInfo.DuplexType)
			{
			case TC_FULL_DUPLEX:	printf(" Full Duplex\n"); break;
			case TC_HALF_DUPLEX:	printf(" Half Duplex\n"); break;
			default:				printf(" Unknown Duplex\n"); break;
			}
		}
		else
		{
			printf("DOWN\n");
		}

		printf("Please disconnect the port and press ENTER");
		fflush(stdin);
#ifdef _WIN32
		_getch();
#else
		scanf("%c", &ch);
		scanf("%c", &ch);
#endif
		
		status = TcPortQueryLinkStatus(port, &linkInfo);
		if (status != TC_SUCCESS) break;
		
		if (linkInfo.LinkUp == TRUE)
		{
			printf("Link appears to be UP. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}

		printf("Test PASSED\n");

		printf("Please connect the port to a 100Mbps Full duplex link and press ENTER");
		fflush(stdin);
#ifdef _WIN32
		_getch();
#else
		scanf("%c", &ch);
#endif

		
		status = TcPortQueryLinkStatus(port, &linkInfo);
		if (status != TC_SUCCESS) break;
		
		if (linkInfo.LinkUp == FALSE)
		{
			printf("Link appears to be DOWN. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}
		if (linkInfo.LinkSpeed != 100)
		{
			printf("Link appears to be at %uMbps. Error\n", linkInfo.LinkSpeed);
			status = TC_ERROR_UNKNOWN;
			break;
		}
		if (linkInfo.DuplexType != TC_FULL_DUPLEX)
		{
			printf("Link is not full duplex. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}

		printf("Test PASSED\n");

		printf("Please disconnect the port and press ENTER");
		fflush(stdin);
#ifdef _WIN32
		_getch();
#else
		scanf("%c", &ch);
#endif
		
		status = TcPortQueryLinkStatus(port, &linkInfo);
		if (status != TC_SUCCESS) break;
		
		if (linkInfo.LinkUp == TRUE)
		{
			printf("Link appears to be UP. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}

		printf("Test PASSED\n");

		printf("Please connect the port to a 1000Mbps Full duplex link and press ENTER");
		fflush(stdin);
#ifdef _WIN32
		_getch();
#else
		scanf("%c", &ch);
#endif
		
		status = TcPortQueryLinkStatus(port, &linkInfo);
		if (status != TC_SUCCESS) break;
		
		if (linkInfo.LinkUp == FALSE)
		{
			printf("Link appears to be DOWN. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}
		if (linkInfo.LinkSpeed != 1000)
		{
			printf("Link appears to be at %uMbps. Error\n", linkInfo.LinkSpeed);
			status = TC_ERROR_UNKNOWN;
			break;
		}
		if (linkInfo.DuplexType != TC_FULL_DUPLEX)
		{
			printf("Link is not full duplex. Error\n");
			status = TC_ERROR_UNKNOWN;
			break;
		}

		printf("Test PASSED\n");

	}while(FALSE);

	TcFreePortList(portList);

	if (status != TC_SUCCESS)
		return -1;

	return 0;

}

